<?php

/*
 * @package RS-MINI
 * @copyright (c) 2015 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

namespace core;

if(!defined('RS-MINI')) die();

/*
 * application v 1.0
 * 
 * Класс стартует систему
 *
 */

class application
{
    /*
     * объект с картой сайта
     *
     * @var         - object
     * @access      - private
     */
    
    private static $map;

    /*
     * объект дома
     *
     * @var         - object
     * @access      - private
     */
    
    private static $dom;

    /*
     * главный метод. запуск системы
     * 
     * @access  - public
     * 
     */
     
    public static function run()
    {
        // поднимаем некоторые классы ядра
        // объект по работе с структурой сайта
        self::$map = new map();
        // объект прослойка между контроллерами и вьюшкой
        self::$dom = new dom();
        
        // стартуем подключение к БД
        sql::setConnect();
        
        // получаем открываемую страницу
        if (!self::$map->getPage())
            self::notFound();
            
        // мероприятия по объеденению унаследованных контроллеров с конечной страницей
        self::unionRun();
        
        // тест работы роутинга
        // просматриваем массив объектов страниц
        ?><xmp><?
        var_dump(self::$map->pageList);
        ?></xmp><?
    }
    
    /*
     * метод добавляет унаследованные контроллеры в вложенные страницы
     * 
     * @access - private
     * 
     */

    private static function unionRun()
    {
        // массив с контроллерами которые отмечены как наследуемые.
        // при первой итерации массив пуст
        $inherit = array();

        // листаем страницы
        for ($key = 0; isset(self::$map->pageList[$key]); $key++) {
            // если массив хранящий контроллеры которые передаются по наследству не пуст
            // то запускаем спец метод который запишет унаследованные контроллеры
            // в обрабатываемую страницу (при первой итерации этот массив пуст)
            if (!empty($inherit)) {
                // сливаем контроллеры родительской страницы и текцщей
                self::$map->pageList[$key]->unionController($inherit);
                // сбрасываем массив
                $inherit = array();
            }
            
            // если на странице есть контроллеры
            if (self::$map->pageList[$key]->controllerList)
                // листаем блоки контроллеров
                foreach (self::$map->pageList[$key]->controllerList as $block => $controllerList)
                    // листаем контроллеры блока
                    foreach ($controllerList as $controller) {
                        // если итерация страниц не последняя (т.е. если страница не последняя)
                        if ($key != (count(self::$map->pageList) - 1))
                            // если контроллер отмечен как наследуемый
                            if ($controller->controllerInherit == 'true')
                                // заносим объект контроллера в массив inherit
                                // для передачи этого объекта по наследству в
                                // дочернию страницу
                                $inherit[$block][] = $controller;
                    }
        }
    }
    
    /*
     * метод выводит 404 ошибку
     * 
     * @access - private
     */

    private static function notFound()
    {
        header('HTTP/1.0 404 Not Fount');
        die('404 error');
    }
}
